/***************************************************************************
 *                                                                         *
 *   LIBVAR.H                                                              *
 *                                                                         *
 *   Copyright (c) 1997 Galacticomm, Inc.                                  *
 *                                                                         *
 *                                                                         *
 *   Library Variables Class.                                              *
 *                                                 - N.C. Osterc  11/06/98 *
 *                                                                         *
 ***************************************************************************/

#ifndef __LIBVAR_H
#define __LIBVAR_H

#define CHK   "checked"

class libManVar {
public:

     libManVar();                  // default constructor

     ~libManVar();                 // destructor

     VOID
     setVarsDefault();             // set variables to default

     VOID
     setLibraryVars(               // set up library variables
     library *libptr);             // passed pointer to library object

     VOID
     setFileVars(                  // set up file variables
     file *filptr);                // passed pointer to file object

     VOID
     setCreateValues();            // set up values for lib creatoin
};

extern basicTvb t_AltPath;                // FLEDIT_ALTPATH
extern basicTvb t_AuditDLs;               // FLEDIT_AUDITDOWN_CHECKED
extern basicTvb t_AuditULs;               // FLEDIT_AUDITUP_CHECKED
extern basicTvb t_CreateDate;             // FLEDIT_CRDATE
extern basicTvb t_CreateTime;             // FLEDIT_CRTIME
extern basicTvb t_DLKey;                  // FLEDIT_DL_KEY
extern basicTvb t_DLCharge;               // FLEDIT_DL_CHARGEFILE
extern basicTvb t_DLChargeK;              // FLEDIT_DL_CHARGEK
extern basicTvb t_OSOnly;                 // FLEDIT_OS_ONLY
extern basicTvb t_Hidden;                 // FLEDIT_HIDDEN_CHECKED
extern basicTvb t_IsCreate;               // FLEDIT_ISCREATE
extern basicTvb t_LibOp;                  // FLEDIT_LIBOP
extern basicTvb t_LibOpKey;               // FLEDIT_LIBOP_KEY
extern urlEncodedTvb t_LibOpEnc;          // FLEDIT_LIBOP_U
extern basicTvb t_LongDesc;               // FLEDIT_LONGDESC
extern basicTvb t_MaxBytes;               // FLEDIT_MAXBYTES
extern basicTvb t_MaxFiles;               // FLEDIT_MAXFILES
extern basicTvb t_MaxUpload;              // FLEDIT_MAXUPLOAD
extern basicTvb t_Name;                   // FLEDIT_NAME
extern basicTvb t_NameEnc;                // FLEDIT_NAME_U
extern basicTvb t_NoAuditDLs;             // FLEDIT_NO_AUDITDOWN_CHECKED
extern basicTvb t_NoAuditULs;             // FLEDIT_NO_AUDITUP_CHECKED
extern basicTvb t_NoTimeChargeDL;         // FLEDIT_NO_TIMECHARGE_DL_CHECKED
extern basicTvb t_NoTimeChargeUL;         // FLEDIT_NO_TIMECHARGE_UL_CHECKED
extern basicTvb t_NotHidden;              // FLEDIT_NOT_HIDDEN_CHECKED
extern basicTvb t_NotOnCD;                // FLEDIT_NOT_ONCD_CHECKED
extern basicTvb t_NotReadOnly;            // FLEDIT_NOT_READONLY_CHECKED
extern basicTvb t_OnCd;                   // FLEDIT_ONCD_CHECKED
extern basicTvb t_OverwriteKey;           // FLEDIT_OVERWRITE_KEY
extern basicTvb t_PreApproveKey;          // FLEDIT_PREAPV_KEY
extern basicTvb t_ReadOnly;               // FLEDIT_READONLY_CHECKED
extern basicTvb t_Royalty;                // FLEDIT_ROYALTY
extern basicTvb t_ShortDesc;              // FLEDIT_SHORTDESC
extern basicTvb t_TimeChargeDL;           // FLEDIT_TIMECHARGE_DL
extern basicTvb t_TimeChargeUL;           // FLEDIT_TIMECHARGE_UL
extern basicTvb t_UploadKey;              // FLEDIT_UL_KEY
extern basicTvb t_VisibleKey;             // FLEDIT_VIS_KEY
extern basicTvb t_ErrMessage;             // FLMAN_ERR_MESSAGE
extern basicTvb t_FileLongDesc;           // FEDIT_LONGDESC
extern basicTvb t_FileName;               // FEDIT_FILENAME
extern urlEncodedTvb t_FileNameEnc;       // FEDIT_FILENAME_U
extern basicTvb t_FileSizeBytes;          // FEDIT_SIZE_BYTES
extern basicTvb t_FileSizeK;              // FEDIT_SIZE_K
extern basicTvb t_DateAdded;              // FEDIT_DATE_ADDED
extern basicTvb t_TimeAdded;              // FEDIT_TIME_ADDED
extern basicTvb t_FileShortDesc;          // FEDIT_SHORTDESC
extern basicTvb t_TimeStamp;              // FEDIT_TIMESTAMP
extern basicTvb t_DateStamp;              // FEDIT_DATESTAMP
extern basicTvb t_Uploader;               // FEDIT_UPLOADER
extern urlEncodedTvb t_UploaderEnc;       // FEDIT_UPLOADER_U
extern basicTvb t_Downloads;              // FEDIT_DOWNLOADS

extern basicTvb t_NumFilesInLib;          // FLEDIT_NUMFILES
extern basicTvb t_NumFilesInLibPlusJoined;// FLEDIT_NUMFILES_JOINED
extern basicTvb t_AddedToday;             // FLEDIT_ADDEDTODAY
extern basicTvb t_WeekAdded;              // FLEDIT_ADDEDTHISWEEK

extern basicTvb t_JoinedLib;              // FLEDIT_JOINED_LIB
extern urlEncodedTvb t_JoinedLibEnc;      // FLEDIT_JOINED_LIB_U
extern basicTvb t_NoneJoined;             // FLEDIT_NONE_JOINED
extern basicTvb t_LoggedFile;             // FLEDIT_LOGFILE
extern urlEncodedTvb t_LoggedFileEnc;     // FLEDIT_LOGFILE_U
extern basicTvb t_NoneLogged;             // FLEDIT_NONE_LOGGED

#endif                             __LIBVAR_H
