###############################################################################
#####                 This makefile generates GALTELE.DLL                 #####
###############################################################################
!include $(WGDEV)\src\gcrules.mak

!if $(OS) == DOS
!    if $(MODEL) == LARGE
!         error GALTELE not supported in Large Model under DOS!
!    endif
     DLLLIB = $(DLLLIB) $(COMPILER)\lib\mathh.lib
     PRODLL = $(PRODLL) $(DOSEXT)\bc5\lib\fpdmy
!endif

PARSEOPTS = $(PARSEOPTS) -D__BUILDTELE

DEFILE = $(TEMPDIR)\galtele.def

DLLLIB =            \
     $(DLLLIB)      \
     wgserver.lib   \
     galgsbl.lib    \
     galsmb.lib     \
     galme.lib

!if $(OS) == DOS
DLLLIB =            \
     $(DLLLIB)      \
     bch286.lib
!endif

!if $(OS) == WNT
DLLLIB =            \
     $(DLLLIB)      \
     galacth.lib
!endif

OBJFILES =          \
     smbwrap.obj    \
     objmap.obj     \
     tlcfunc.obj    \
     tlccmdl.obj    \
     tlcapi.obj     \
     tlc.obj        \
     tlctm.obj      \
     tlctmtra.obj   \
     tlccs.obj      \
     tlccsdp.obj    \
     tlccstra.obj   \
     tlcchan.obj    \
     tlctrans.obj   \
     tlcuser.obj    \
     tlccmd.obj     \
     tlcfsd.obj     \
     tlcdcmd.obj    \
     tlcact.obj     \
     tlcactc.obj    \
     tlcpal.obj     \
     tlcapic.obj    \
     tlcdyntr.obj   \
     tlcdyncm.obj   \
     tlcdynch.obj   \
     tlcsyedt.obj   \
     tlcfchn.obj

 !if $(OS) == WNT
OBJFILES =          \
     $(OBJFILES)    \
     ahutil.obj     \
     tlcah.obj      \
     tlcsysah.obj   \
     ahtrans.obj    \
     tlcahlit.obj   \
     ahlite.obj     \
     strings.obj    \
     tlcahusr.obj   \
     tlcahpag.obj   \
     tlcahtvb.obj   \
     enctvb.obj
!endif

VIRFILES =          \
     galtelu3.vir  \
     galtelx.vir   \
     galtel.vir    \
     galtela.vir   \
     galtelp.vir

start:              \
     $(GCBUILD)     \
     galtele.dll
!if $d(BUILD)
     galcopy galteltm.doc $(RUNDIR)
     galcopy tagfltr.txt $(RUNDIR)
     galmkdir $(RUNDIR)\GALACTH\GALTELE\VIR
     CD .\HTML
     galparsf &&|
          $(PARSEOPTS)
          *.HTM
|    $(RUNDIR)\GALACTH\GALTELE\VIR -B -Q
     CD ..
     galmkdir $(RUNDIR)\GALACTH\GALTELE\FILE\VIR
     CD .\HTML\FILE
     galparsf &&|
          $(PARSEOPTS)
          *.HTM
|    $(RUNDIR)\GALACTH\GALTELE\FILE\VIR -B -Q
     CD ..\..
     galmkdir $(RUNDIR)\GALACTH\GALTELE\PROFILE\VIR
     CD .\HTML\PROFILE
     galparsf &&|
          $(PARSEOPTS)
          *.HTM
|    $(RUNDIR)\GALACTH\GALTELE\PROFILE\VIR -B -Q
     CD ..\..
     galmkdir $(RUNDIR)\GALACTH\GALTELE\RECEIVE\VIR
     CD .\HTML\RECEIVE
     galparsf &&|
          $(PARSEOPTS)
          *.HTM
|    $(RUNDIR)\GALACTH\GALTELE\RECEIVE\VIR -B -Q
     CD ..\..
     galmkdir $(RUNDIR)\GALACTH\GALTELE\LIST\VIR
     CD .\HTML\LIST
          galparsf &&|
          $(PARSEOPTS)
          *.HTM
|    $(RUNDIR)\GALACTH\GALTELE\LIST\VIR -B -Q
     CD ..\..
     galmkdir $(RUNDIR)\GALACTH\GALTELE\LIST\USER\VIR
     CD .\HTML\LIST\USER
     galparsf &&|
          $(PARSEOPTS)
          *.HTM
|    $(RUNDIR)\GALACTH\GALTELE\LIST\USER\VIR -B -Q
     CD ..\..\..
     galmkdir $(RUNDIR)\GALACTH\GALTELE\LIST\ACTION\VIR
     CD .\HTML\LIST\ACTION
     galparsf &&|
          $(PARSEOPTS)
          *.HTM
|    $(RUNDIR)\GALACTH\GALTELE\LIST\ACTION\VIR -B -Q
     CD ..\..\..
     galmkdir $(RUNDIR)\GALACTH\GALTELE\LIST\CHANNEL\VIR
     CD .\HTML\LIST\CHANNEL
     galparsf &&|
          $(PARSEOPTS)
          *.HTM
|    $(RUNDIR)\GALACTH\GALTELE\LIST\CHANNEL\VIR -B -Q
     CD ..\..\..
!endif


galtele.dll:        \
     galtele.h      \
     galwebd.h      \
     wgsmajor.h     \
     $(OBJFILES)    \
     $(DLLLIB)      \
     $(DEFILE)      \
     $(VIRFILES)
     $(LINK) $(LIBCMD) @&&|
$(PRODLL) $(MATHDLL) $(OBJFILES)
$(RUNDIR)\$&
$(RUNDIR)\$&
$(DLLLIB) $(LINKDLL)
$(DEFILE)
|

