#############################################################################
##  Compile/Linking info for BORLAND 4.5 compiler                          ##
#############################################################################
!if !$d(BORLAND)
!    error "BORLAND Environment variable not set!"
!endif
!if !$d(PHARLAP)
!    error "PHARLAP Environment variable not set!"
!endif

CC      = $(BORLAND)\bin\bcc
LINK    = $(BORLAND)\bin\tlink
AS      = $(BORLAND)\bin\tasmx /i$(INCDIR)
IMPLIB  = $(BORLAND)\bin\implib

INCCMD  = -I$(STDINC)
INCCMD1 = -I$(WGSRCDIR);$(BORLAND)\include;$(PHARLAP)\inc

#############################################################################
##  Large model stuff                                                      ##
#############################################################################
!if $(MODEL) == LARGE
     AS      = $(AS) /DLARGEMAC
     CFIG    = -P-c -d -DTSC_C -ml -Tt -K -c           \
               -Ob -Oe -Os -k- -Ol -Op -g$(NUMERRS)    \
               -weas -wpin -wamb -wamp -wdef -wnod     \
               -wstv -wuse -wcln -wsig -wucp -w-pro -w-eff
     PROEXE  = $(BORLAND)\lib\c0l.obj
     PRODLL  =                               # Large model no DLL support
     GUIEXE  = $(BORLAND)\lib\c0l.obj        # To keep .MAK files compat.
     LINKEXE = /m /n /s /Tde
     LINKGUI = /m /n /s /Tde
     LINKDLL =                               # Large model no DLL support
     EXTLIB  =                               # Large model no Phar Lap
     DLLLIB  =                               # Large model no DLL support
     DEFILE  = $(WGLIBDIR)\nodef.def         # Large model no DLL support
     MATHDEF =                               # Large model no DLL support
     OBJCMD  = -n$(OBJDIR)
!if $d(DEBUG)
     LIBNAME = $(WGLIBDIR)\ldgcomm.lib
     IMLIB   = $(WGLIBDIR)\wgsimld.lib
!else
     LIBNAME = $(WGLIBDIR)\lgcomm.lib
     IMLIB   = $(WGLIBDIR)\wgsiml.lib
!endif
     EXELIB  = $(LIBNAME) $(BORLAND)\lib\cl.lib
     STATLIB = $(EXELIB)
     LIBCMD  = -L$(DLIBDIR);$(WGLIBDIR);$(BORLAND)\lib

!elif $(MODEL) == PHARLAP
#############################################################################
##  Pharlap model                                                          ##
#############################################################################
     AS      = $(AS) /DHUGEMAC
     CFIG    = -DPACSOFT -2 -P-c -d -DTSC_C -mh! -h -Tt     \
               -K -c -Ob -Oe -Os -k- -Ol -Op -g$(NUMERRS)   \
               -weas -wpin -wamb -wamp -wdef -wnod -w-pro   \
               -wstv -wuse -wcln -wsig -wucp -w-eff
     PROEXE  = $(PHARLAP)\bc4\lib\c0ph.obj
     PRODLL  = $(PHARLAP)\bc4\lib\c0phdll.obj
     GUIEXE  = $(PHARLAP)\bc4\lib\c0ph.obj
     LINKEXE = /m /n /s /Twe
     LINKGUI = /m /n /s /Twe
     LINKDLL = /m /n /s /Twd
     EXTLIB  = $(PHARLAP)\bc4\lib\phapi.lib
     DLLLIB  = $(EXTLIB)
     DEFILE  = nodef.def
     MATHDEF = mathdef.def
     OBJCMD  = -n$(OBJDIR)
!if $d(DEBUG)
     LIBNAME = $(WGLIBDIR)\pdgcomm.lib
     DFCLIB  = $(WGLIBDIR)\pddfcapi.lib
!else
     LIBNAME = $(WGLIBDIR)\pgcomm.lib
     DFCLIB  = $(WGLIBDIR)\pdfcapi.lib
!endif
     EXELIB = $(LIBNAME)
     STATLIB = $(EXELIB)
     LIBCMD = -L$(DLIBDIR);$(WGLIBDIR);$(PHARLAP)\bc4\lib;$(BORLAND)\lib

!else
#############################################################################
##  No model specified                                                     ##
#############################################################################
!error "NO COMPILER MODEL SPECIFIED!"
!endif
