#############################################################################
##  Borland C 16 bit compiler options                                      ##
#############################################################################
!if !$d(BC50)
!    error "BC50 Environment variable not set correctly!"
!endif

CC      = $(BC50)\bin\bcc
LINK    = $(BC50)\bin\tlink
AS      = $(BC50)\bin\tasmx /i$(INCDIR)
IMPLIB  = $(BC50)\bin\implib

INCCMD  = /I$(STDINC)
INCCMD1 = /I$(WGSRCDIR);$(BC50)\include;$(DOSEXT)\inc

#############################################################################
##  Large model stuff                                                      ##
#############################################################################
!if $(MODEL) == LARGE
     AS      = $(AS) /DLARGEMAC
     CFIG    = -P-c -d -DTSC_C -ml -Tt -K -c           \
               -Ob -Oe -Os -k- -Ol -Op -g$(NUMERRS)    \
               -weas -wpin -wamb -wamp -wdef -wnod     \
               -wstv -wuse -wcln -wsig -wucp -w-pro
     PROEXE  = $(BC50)\lib\c0l.obj
     PRODLL  =                               # Large model no DLL support
     GUIEXE  = $(BC50)\lib\c0l.obj           # To keep .MAK files compat.
     LINKEXE = /j$(OBJDIR) /m /n /s /Tde
     LINKGUI = /j$(OBJDIR) /m /n /s /Tde
     LINKDLL =                               # Large model no DLL support
     EXTLIB  =                               # Large model no Phar Lap
     DLLLIB  =                               # Large model no DLL support
     DEFILE  = $(WGLIBDIR)\nodef.def         # Large model no DLL support
     MATHDEF =                               # Large model no DLL support
     OBJCMD  = -n$(OBJDIR)
!if $d(DEBUG)
     LIBNAME = $(WGLIBDIR)\ldgcomm.lib
     DFCLIB  = $(WGLIBDIR)\lddfcapi.lib
     IMLIB   = $(WGLIBDIR)\wgsimld.lib
!else
     LIBNAME = $(WGLIBDIR)\lgcomm.lib
     DFCLIB  = $(WGLIBDIR)\ldfcapi.lib
     IMLIB   = $(WGLIBDIR)\wgsiml.lib
!endif
     GCSPLIB =
     EXELIB  = $(LIBNAME) $(BC50)\lib\cl.lib
     STATLIB = $(EXELIB)
     LIBCMD  = /L$(DLIBDIR);$(WGLIBDIR);$(BC50)\lib

!elif $(MODEL) == PHARLAP
#############################################################################
##  Pharlap model                                                          ##
#############################################################################
     AS      = $(AS) /DHUGEMAC
     CFIG    = -2 -P-c -d -DTSC_C -mh! -h -Tt -K -c    \
               -Ob -Oe -Os -k- -Ol -Op -g$(NUMERRS)    \
               -weas -wpin -wamb -wamp -wdef -wnod     \
               -wstv -wuse -wcln -wsig -wucp -w-pro
     PROEXE  = $(DOSEXT)\bc5\lib\c0ph.obj
     PRODLL  = $(DOSEXT)\bc5\lib\c0phdll.obj
     GUIEXE  = $(DOSEXT)\bc5\lib\c0ph.obj
     LINKEXE = -j$(OBJDIR) /m /n /s /Twe
     LINKGUI = -j$(OBJDIR) /m /n /s /Twe
     LINKDLL = -j$(OBJDIR) /m /n /s /Twd
     EXTLIB  = $(DOSEXT)\bc5\lib\phapi.lib
     DLLLIB  = $(EXTLIB)
     DEFILE  = $(WGLIBDIR)\nodef.def
     MATHDEF = mathdef.def
     OBJCMD  = -n$(OBJDIR)
!if $d(DEBUG)
     LIBNAME = $(WGLIBDIR)\pdgcomm.lib
     DFCLIB  = $(WGLIBDIR)\pddfcapi.lib
     IMLIB   = $(WGLIBDIR)\wgsimpd.lib
     GCSPLIB = $(WGLIBDIR)\pdgcsp.lib
!else
     LIBNAME = $(WGLIBDIR)\pgcomm.lib
     IMLIB   = $(WGLIBDIR)\wgsimp.lib
     DFCLIB  = $(WGLIBDIR)\pdfcapi.lib
     GCSPLIB = $(WGLIBDIR)\pgcsp.lib
!endif
     EXELIB = $(LIBNAME)
     STATLIB = $(EXELIB)
     LIBCMD = /L$(DLIBDIR);$(WGLIBDIR);$(DOSEXT)\bc5\lib;$(BC50)\lib
!else

#############################################################################
##  No model specified                                                     ##
#############################################################################
!error "NO COMPILER MODEL SPECIFIED!"
!endif
