###############################################################################
#####               Makefile to generate WGSCNF.EXE                       #####
###############################################################################
!if $(OS) == DOS
!    if $(MODEL) == LARGE
!         error WGSCNF not supported in Large Model for DOS!
!    endif
!else
!    error WGSCNF not supported in Flat Model for NT!
!endif

#############################################################################
##  Include GCRULES.MAK                                                    ##
#############################################################################
!include $(WGDEV)\src\gcrules.mak

PROEXE = $(PROEXE) $(DOSEXT)\bc5\lib\emu286.lib
BTULIB = wgsbtu.lib
CNFLIB = plhide $(EXELIB) $(BTULIB) emu mathh $(EXTLIB) \
          $(DOSEXT)\bc5\lib\bch286
LINKEXE = /m /n /P-
DEFILE = protexe.def

.path.obj = $(OBJDIR)

#############################################################################
##  All other dependencies                                                 ##
#############################################################################
OBJFILES =          \
     cnf.obj        \
     mdldll.obj     \
     mdlogic.obj    \
     cnfscns.obj    \
     edtoff.obj     \
     protstuf.obj   \
     $(WGLIBDIR)\0pbrkthu.obj

wgscnf.exe:                                                                \
     $(GCBUILD)                                                            \
     cnfscns.c                                                             \
     $(BTULIB) $(OBJFILES) $(DEFILE) galgsbl.lib  \
     $(LIBNAME)
     CD $(OBJDIR)
     $(LINK) $(LIBCMD) @&&|
$(PROEXE) $(OBJFILES)
$(RUNDIR)\$&
$(RUNDIR)\$&
$(CNFLIB) $(LINKEXE)
$(DEFILE)
|
     cd $(RUNDIR)
#%if CUSTOMER
     cfig286 wgscnf -ls 8192
#%else
     bind286 $(DOSEXT)\rtk\gorun286 wgscnf -os2
     cfig286 -dosxname wgserver.exe wgscnf -ls 8192
#%endif

cnfscns.c:          \
     mdscn1.scn     \
     mdscn2.scn     \
     mdscn3.scn     \
     mdscn4.scn     \
     mdscn5.scn     \
     mdscn6.scn     \
     cnfinit.scn    \
     galnrip.scn
     $(SCNBGN)
     $(SCNMAK)
     $(SCNEND)
